-----------------------------
-- Bunch of functions inc! --
-----------------------------
function PA_ButtonControl(Button,state)
	if(Button == "Master") then
		if(state == "Enable") then
			PA_SavedSettings["MasterChecked"] = true
			PA_SavedSettings["MillingChecked"] = true
			PA_SavedSettings["ProspectingChecked"] = true
			PA_SavedSettings["EnchantingChecked"] = true
			MillingButton:Enable()
			ProspectingButton:Enable()
			EnchantingButton:Enable()
			if(MillingButton:GetChecked()) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_01) end
			if(ProspectingButton:GetChecked()) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_02) end
			if(EnchantingButton:GetChecked()) then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_03) end
		end
		if(state == "Disable") then
			PA_SavedSettings["MasterChecked"] = false
			PA_SavedSettings["MillingChecked"] = false
			PA_SavedSettings["ProspectingChecked"] = false
			PA_SavedSettings["EnchantingChecked"] = false
			MillingButton:Disable()
			ProspectingButton:Disable()
			EnchantingButton:Disable()
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_01)
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_02)
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_03)
		end
		if(state == "Startup") then
			MillingButton:Enable()
			ProspectingButton:Enable()
			EnchantingButton:Enable()
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_01)
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_02)
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_03)
		end
		if(state == "startup2") then
			MillingButton:Disable()
			ProspectingButton:Disable()
			EnchantingButton:Disable()
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_01)
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_02)
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_03)
		end
	end
	if(Button == "Milling") then
		if(state == "Enable") then
			PA_SavedSettings["MillingChecked"] = true
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_01)
		end
		if(state == "Disable") then
			PA_SavedSettings["MillingChecked"] = false
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_01)
		end
		if(state == "Startup") then	UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_01) end
		if(state == "startup2") then UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_01) end
	end
	if(Button == "Prospecting") then
		if(state == "Enable") then
			PA_SavedSettings["ProspectingChecked"] = true
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_02)
		end
		if(state == "Disable") then
			PA_SavedSettings["ProspectingChecked"] = false
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_02)
		end
		if(state == "Startup") then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_02) end
		if(state == "startup2") then UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_02) end
	end
	if(Button == "Enchanting") then
		if(state == "Enable") then
			PA_SavedSettings["EnchantingChecked"] = true
			UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_03)
		end
		if(state == "Disable") then
			PA_SavedSettings["EnchantingChecked"] = false
			UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_03)
		end
		if(state == "Startup") then UIDropDownMenu_EnableDropDown(PA_interface_dropdownmenu_03) end
		if(state == "startup2") then UIDropDownMenu_DisableDropDown(PA_interface_dropdownmenu_03) end
	end
end
--------------------------
-- Button creator stuff --
--------------------------
local uniquealyzer = 1;
function createCheckbutton(parent, x_loc, y_loc, displayname, description)
	local checkbutton = CreateFrame("CheckButton", "PA_interface_checkbutton_0" .. uniquealyzer, parent, "InterfaceOptionsCheckButtonTemplate");
	uniquealyzer = uniquealyzer + 1;
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
	checkbutton.tooltipText = displayname;
	checkbutton.tooltipRequirement = description;
	
	return checkbutton;
end

----------------------------
-- FontText creator stuff --
----------------------------
function createFonttext(parent, x_loc, y_loc, text, fonttemplate)
	local title = parent:CreateFontString(nil, "ARTWORK", fonttemplate);
	title:SetPoint("TOPLEFT", x_loc, y_loc)
	title:SetText(text)
end

--------------------------------
-- DropDownMenu creator stuff --
--------------------------------
local uniquealyzer2 = 1;
function PA_CreateMenu(parent, x_loc, y_loc, displayname, description)
	local menu = CreateFrame("Button", "PA_interface_dropdownmenu_0" .. uniquealyzer2, parent, "UIDropDownMenuTemplate")
	
	menu:SetPoint("TOPLEFT", x_loc, y_loc)
	menu:Show()
	
	local items = {
		"Always",
		"Shift",
		"Ctrl",
		"Alt"
	}
	
	local function OnClick(self)
		if(menu == PA_interface_dropdownmenu_01) then
			PA_SavedSettings["MillingKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			MillingID = self:GetID();
		end
		if(menu == PA_interface_dropdownmenu_02) then
			PA_SavedSettings["ProspectingKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			ProspectingID = self:GetID();
		end
		if(menu == PA_interface_dropdownmenu_03) then
			PA_SavedSettings["EnchantingKey"] = self:GetID()
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			EnchantingID = self:GetID();
		end
	end
	
	local function init(self, level)
		for k,v in pairs(items) do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = v
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end
	end
	
	menu:SetScript('OnEnter', function(self)
		GameTooltip:SetOwner(self,"ANCHOR_TOPRIGHT")
		GameTooltip:SetText(displayname, nil, nil, nil, 1, 1)
		GameTooltip:AddLine(description, 1, 1, 1)
		GameTooltip:Show()
	end)
	menu:SetScript('OnLeave', function(self) GameTooltip:Hide() end)
	
	UIDropDownMenu_Initialize(menu, init)
	UIDropDownMenu_SetWidth(menu, 75);
	UIDropDownMenu_SetButtonWidth(menu, 50)
	UIDropDownMenu_JustifyText(menu, "LEFT")
	
	uniquealyzer2 = uniquealyzer2 + 1;
end

--------------------------
-- Interface AddOns tab --
--------------------------
local LoadFrame = CreateFrame("Frame")
LoadFrame:RegisterEvent("PLAYER_LOGIN");
LoadFrame:SetScript("OnEvent", function(self,event,...)
	if(type(PA_SavedSettings) ~= "table") then PA_SavedSettings = {} end
	
	if(PA_SavedSettings["MasterChecked"] == nil) then PA_SavedSettings["MasterChecked"] = true
	else PA_SavedSettings["MasterChecked"] = PA_SavedSettings["MasterChecked"] end
	
	if(PA_SavedSettings["MillingChecked"] == nil) then PA_SavedSettings["MillingChecked"] = true
	else PA_SavedSettings["MillingChecked"] = PA_SavedSettings["MillingChecked"] end
	
	if(PA_SavedSettings["ProspectingChecked"] == nil) then PA_SavedSettings["ProspectingChecked"] = true
	else PA_SavedSettings["ProspectingChecked"] = PA_SavedSettings["ProspectingChecked"] end
		
	if(PA_SavedSettings["EnchantingChecked"] == nil) then PA_SavedSettings["EnchantingChecked"] = true
	else PA_SavedSettings["EnchantingChecked"] = PA_SavedSettings["EnchantingChecked"] end
	
	if(PA_SavedSettings["MillingKey"] == nil) then PA_SavedSettings["MillingKey"] = 1
	else PA_SavedSettings["MillingKey"] = PA_SavedSettings["MillingKey"] end
		
	if(PA_SavedSettings["ProspectingKey"] == nil) then PA_SavedSettings["ProspectingKey"] = 1
	else PA_SavedSettings["ProspectingKey"] = PA_SavedSettings["ProspectingKey"] end
	
	if(PA_SavedSettings["EnchantingKey"] == nil) then PA_SavedSettings["EnchantingKey"] = 1
	else PA_SavedSettings["EnchantingKey"] = PA_SavedSettings["EnchantingKey"] end
		
	PA_Panel = {};
	
	-- Main panel
	PA_Panel.Main = CreateFrame( "Frame", "MainPanel", UIParent );
	PA_Panel.Main.name = "Profession Assistance";
	
	-- title
	--createFonttext(Parent, Positionx, Positiony, text, template)
	createFonttext(PA_Panel.Main, 15, -15, "Profession Assistance", "GameFontNormalLarge")
	
	-- content
	createFonttext(PA_Panel.Main, 20, -80, "|cffffcc00Version|r     "..GetAddOnMetadata("Profession_Assistance","Version"), "GameFontHighlight")
	createFonttext(PA_Panel.Main, 20, -95, "|cffffcc00Notes|r       "..GetAddOnMetadata("Profession_Assistance","Notes"), "GameFontHighlight")
	createFonttext(PA_Panel.Main, 20, -125, "|cffffcc00Author|r     "..GetAddOnMetadata("Profession_Assistance","Author"), "GameFontHighlight")
	createFonttext(PA_Panel.Main, 20, -140, "|cffffcc00Credits|r     "..GetAddOnMetadata("Profession_Assistance","X-Credits"), "GameFontHighlight")
	
	InterfaceOptions_AddCategory(PA_Panel.Main);
	
	
	-- Options panel
	PA_Panel.Options = CreateFrame( "Frame", "OptionsPanel", PA_Panel.Main);
	PA_Panel.Options.name = "Options";
	
	-- title
	createFonttext(PA_Panel.Options, 15, -15, "Options", "GameFontNormalLarge")
	
	-- content
	createFonttext(PA_Panel.Options, 20, -60, "|cffffcc00Global|r", "GameFontNormalLarge")
	-- createCheckbutton(Parent, Positionx, positiony, label, description);
	MasterButton = createCheckbutton(PA_Panel.Options, 15, -80, "Enabled", "Master switch");
	MasterButton:SetChecked(PA_SavedSettings["MasterChecked"])
	
	createFonttext(PA_Panel.Options, 320, -60, "|cffffcc00Milling|r", "GameFontNormalLarge")	
	MillingButton = createCheckbutton(PA_Panel.Options, 315, -80, "Enabled", "Toggle milling information on herbs");
	MillingButton:SetChecked(PA_SavedSettings["MillingChecked"])
	
	createFonttext(PA_Panel.Options, 320, -115, "Shown when: ", "GameFontNormalSmall")
	PA_CreateMenu(PA_Panel.Options, 305, -130, "Appearance control: ","Select one option to make it appear on keyhold or just always");
	UIDropDownMenu_SetSelectedID(PA_interface_dropdownmenu_01, PA_SavedSettings["MillingKey"])
	
	createFonttext(PA_Panel.Options, 20, -260, "|cffffcc00Prospecting|r", "GameFontNormalLarge")
	ProspectingButton = createCheckbutton(PA_Panel.Options, 15, -280, "Enabled", "Toggle prospecting information on ores");
	ProspectingButton:SetChecked(PA_SavedSettings["ProspectingChecked"])
	
	createFonttext(PA_Panel.Options, 20, -315, "Shown when: ", "GameFontNormalSmall")
	PA_CreateMenu(PA_Panel.Options, 5, -330, "Appearance control", "Select one option to make it appear on keyhold or just always")
	UIDropDownMenu_SetSelectedID(PA_interface_dropdownmenu_02, PA_SavedSettings["ProspectingKey"])
	
	createFonttext(PA_Panel.Options, 320, -260, "|cffffcc00Enchanting|r", "GameFontNormalLarge")
	EnchantingButton = createCheckbutton(PA_Panel.Options, 315, -280, "Enabled", "Toggle enchanting information on gear");
	EnchantingButton:SetChecked(PA_SavedSettings["EnchantingChecked"])
	
	createFonttext(PA_Panel.Options, 320, -315, "Shown when: ", "GameFontNormalSmall")
	PA_CreateMenu(PA_Panel.Options, 305, -330, "Appearance control", "Select one option to make it appear on keyhold or just always")
	UIDropDownMenu_SetSelectedID(PA_interface_dropdownmenu_03, PA_SavedSettings["EnchantingKey"])
	
	---------------------------
	-- Changing settings part --
	---------------------------
	-- master button
	MasterButton:SetScript("OnClick", function() if(MasterButton:GetChecked()) then PA_ButtonControl("Master","Enable") else PA_ButtonControl("Master","Disable") end end);
	--PA_ButtonControl(Button,state)
	if(PA_SavedSettings["MasterChecked"])then PA_ButtonControl("Master","startup") else PA_ButtonControl("Master","startup2") end
	
	-- Milling stuff
	MillingButton:SetScript("OnClick", function() if(MillingButton:GetChecked()) then PA_ButtonControl("Milling","Enable") else PA_ButtonControl("Milling","Disable") end end);
	if(PA_SavedSettings["MillingChecked"])then PA_ButtonControl("Milling","startup") else PA_ButtonControl("Milling","startup2") end
	MillingID = PA_SavedSettings["MillingKey"]
	
	-- Prospecting stuff
	ProspectingButton:SetScript("OnClick", function() if(ProspectingButton:GetChecked()) then PA_ButtonControl("Prospecting","Enable") else PA_ButtonControl("Prospecting","Disable") end end);
	if(PA_SavedSettings["ProspectingChecked"])then PA_ButtonControl("Prospecting","startup") else PA_ButtonControl("Prospecting","startup2") end
	ProspectingID = PA_SavedSettings["ProspectingKey"]
	
	-- Enchanting stuff
	EnchantingButton:SetScript("OnClick", function() if(EnchantingButton:GetChecked()) then PA_ButtonControl("Enchanting","Enable") else PA_ButtonControl("Enchanting","Disable") end end);
	if(PA_SavedSettings["EnchantingChecked"])then PA_ButtonControl("Enchanting","startup") else PA_ButtonControl("Enchanting","startup2") end
	EnchantingID = PA_SavedSettings["EnchantingKey"]
	
	PA_Panel.Options.parent = PA_Panel.Main.name;
	InterfaceOptions_AddCategory(PA_Panel.Options);
	
	-- Profile panel
	PA_Panel.Profile = CreateFrame( "Frame", "ProfileOptions", PA_Panel.Main);
	PA_Panel.Profile.name = "Profile";
	
	-- title
	createFonttext(PA_Panel.Profile, 15, -15, "Profile", "GameFontNormalLarge")
	
	-- content
	createFonttext(PA_Panel.Profile, 15, -35, "Coming soon!", "GameFontHighlight")
	
	PA_Panel.Profile.parent = PA_Panel.Main.name;
	InterfaceOptions_AddCategory(PA_Panel.Profile);
end)